# ------------------------------------------------------------------------------
# Copyright (C) 2022 Anton Synytsia & Rich O'Brien
#
# ------------------------------------------------------------------------------

require 'sketchup.rb'
require 'extensions.rb'

fpath = __FILE__.dup
fpath.force_encoding('UTF-8') if fpath.respond_to?(:force_encoding)

unless file_loaded?(fpath)
  file_loaded(fpath)

  module AMS
    module PieMenu

      NAME = '圆盘菜单-草图联盟网汉化(cnwhc.com)'.freeze

      MAJOR_VERSION = 0.freeze
      MINOR_VERSION = 9.freeze
      PATCH_VERSION = 4.freeze
      DEVEL_VERSION = 0.freeze

      VERSION_INT = (MAJOR_VERSION * 1000 + MINOR_VERSION * 100 + PATCH_VERSION * 10 + DEVEL_VERSION).to_i
      VERSION = sprintf("%d.%d.%d%c", MAJOR_VERSION, MINOR_VERSION, PATCH_VERSION, DEVEL_VERSION + 0x61).freeze

      RELEASE_YEAR_START = 2021.freeze
      RELEASE_YEAR_END = 2022.freeze
      RELEASE_DATE = '2 February 2022'.freeze

      PRODUCTION = true

      REQUIRED_SKETCHUCATION_VERSION = "4.2.0".freeze

      cfpath = __FILE__.dup
      cfpath.force_encoding('UTF-8') if cfpath.respond_to?(:force_encoding)
      efpath = ::File.expand_path('../!ams_PieMenu/main_entry', cfpath)
      @extension = ::SketchupExtension.new(NAME, efpath)

      desc = "A circular menu experience for Windows users."

      @extension.description = desc
      @extension.version = VERSION
      if (RELEASE_YEAR_START == RELEASE_YEAR_END)
        @extension.copyright = "(C) #{RELEASE_YEAR_START} Anton Synytsia & Rich O'Brien"
      else
        @extension.copyright = "(C) #{RELEASE_YEAR_START} - #{RELEASE_YEAR_END} Anton Synytsia & Rich O'Brien"
      end
      @extension.creator = "Anton Synytsia & Rich O'Brien"

      ::Sketchup.register_extension(@extension, true)

      class << self
        attr_reader :extension
      end # class << self

    end # module PieMenu
  end # module AMS

  if AMS::PieMenu.extension.respond_to?(:check)
    AMS::PieMenu.extension.check
  end

end
